/**
 * @author xiong
 * @example
 * platform.devActive();    //loading前调用
 * platform.serverLogin();  //loading后调用
 * platform.reportNewLevel( {$level} ) //通过当前最大关卡时，上报等级
 */


var config = window.__CONFIG__ || {};

var interface = {
    devActive: "https://game.himengyou.com/Active/html5",
    reportNewLevel: "https://game.himengyou.com/Event/html5",
    login: "https://wx-api.himengyou.com/user/login/",
    gameConfig: "https://static.51kantu.cn/json/zhaocha/v{$sdkver}/game_config_{$media}.json"
};

var storeName = {
    imeiCode: "imeiCode",
    devCode: "devCode"
};

var PlatformWeb = function(){
}();

var PlatformOppo = function(){
}();

var PlatformVivo = function(){
}();

var PlatformiOS = function(){
}();

var PlatformUC = function(){
    function PlatformUC() {
        this.platformType = "uc";
        this.__rewardAdIsPlaying = false;
        return this;
    }

    PlatformUC.prototype.vibrateShort = function(){

    },

    /**
     * 获取imei码
     */
    PlatformUC.prototype.getImeiCode = function() {
        var _imei,
            imeiName = storeName.imeiCode;

        _imei = window.localStorage.getItem(imeiName);

        if (!_imei) {
            var rand = Math.floor(10000000 * Math.random()) + "" + new Date().getTime();
            _imei = MD5(rand).slice(0, 15);
            window.localStorage.setItem(imeiName, _imei);
        }

        return _imei;
    };

    /**
     * 获取设备码
     */
    PlatformUC.prototype.getDevCode = function() {
        var _imei, _dev, _salt = "salt_sx1kedsl",
        devName = storeName.devCode;

        _dev = window.localStorage.getItem(devName);

        if (!_dev) {
            _imei = this.getImeiCode();
            _dev = MD5(_imei + _salt);
            window.localStorage.setItem(devName, _dev);
        }

        return _dev;
    };


    PlatformUC.prototype.getSystemInfo = function(callback){
        if( window.uc && callback ){
            return callback.call(this, window.uc.getSystemInfoSync());
        } else {
            return console.log( "[getSystemInfo] uc is null" );
        }

        /*
            {
            pixelRatio: 3,       // 设备像素比录
            screenWidth: 1280,   // 屏幕宽度，单位px
            screenHeight: 2280,  // 屏幕高度，单位px
            windowWidth: 1280,   // 可使用窗口宽度，单位px
            windowHeight: 2280,  // 可使用窗口高度，单位px
            brand: "",					 // 渠道信息
            model: "xiaomi",	   // 设备信息
            version: "12.5.6",   // UC端版本
            system: "9.0", 			 // 系统版本
            platform:"android",  // 系统平台
            SDKVersion:"1.0.0"	 // 游戏平台版本
            }
        */
    };

    PlatformUC.prototype.devActive = function(){
        console.log("[devActive] 设备登录开始");
        var _this = this;

        this.getSystemInfo(function(devInfo){
            console.log("[devActive] getSystemInfo=", devInfo);

            if( devInfo && typeof devInfo == "string" ){
                devInfo = JSON.parse( devInfo );
                console.log( "[devActive] data parse=", devInfo );
            }

            if( !devInfo ) {
                return console.log( "[devActive] data error" );
            }

            var url = interface.devActive;
            var _imei = _this.getImeiCode();
            var _dev = this.getDevCode();
            var sysType = 0;
            var OSversion = devInfo.system;
            var networkType = "unkown";
            // var pixelRatio = devInfo.pixelRatio;
            var width = devInfo.screenWidth;
            var height = devInfo.screenHeight;

            if( devInfo.platform === "android" ){
                sysType = 2;
            } else if( devInfo.platform === "ios" ) {
                sysType = 1;
            }

            window.localStorage.setItem(storeName.imeiCode, _imei);
            window.localStorage.setItem(storeName.devCode, _dev);


            console.log("[devActive] 网络状态正常，网络类型=", networkType);

            var arr = [
                "refer=" + config.refer,
                "dev=" + _dev,
                "imei=" + _imei,
                "os=" + sysType,
                "gname=" + encodeURIComponent(config.gname),
                "dpgn=" + config.pkgName,
                "brand=" + encodeURIComponent(devInfo.brand),
                "mode=" + encodeURIComponent(devInfo.model),
                "sver=" + config.sdkVersion,
                "wpi=" + width,
                "hpi=" + height,
                "osver=" + encodeURIComponent(OSversion),
                "pver=" + config.reviewVersion,
                "nwk=" + networkType,
                "token=" + MD5(Math.random()*1000000)
            ];

            url = url + "?" + arr.join("&");
            console.log("[devActive] url=", arr.join("&"));

            var img = new Image();
            img.src = url;
            img.onload = function(){
                console.log( "[devActive] 设备登录成功" );
            }
        });
    };
    PlatformUC.prototype.serverLogin = function(){};

    /**
    * 等级通关上报
    */
   PlatformUC.prototype.reportNewLevel = function(level, type) {
        type = type || 1;
        var data2 = [
            "refer=" + config.refer,
            "uid=",
            "dev=" + this.getDevCode(),
            "eid=" + (type == 2 ? 38 : 35),
            "drlevel=" + (level || 0)
        ],

        _url = interface.reportNewLevel + "?" + data2.join("&") + "&r=" + Math.random();

        console.log( "[reportNewLevel] url=", _url );

        var img = new Image();
        img.src = _url;
        img.onload = function(){
            console.log( "[reportNewLevel] 上报成功！上报等级=", level );
        }
    };

    PlatformUC.prototype.reportEventsClick = function(){};

    PlatformUC.prototype.getGameConfig = function(callback) {
        var _this = this;
        var url = interface.gameConfig + "?v=" + Math.random();
        url = url.replace( "{$sdkver}", config.sdkVersion )
        .replace( "{$media}", config.media );

        var xhr = new XMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.addEventListener("load", function () {
            if( xhr.response ){
                var res = JSON.parse(xhr.response);
                window.popAd = res.popAd;

                callback && callback.call( this, res );
            }
        });
        xhr.send(null);
    };


    PlatformUC.prototype.getHidden = function() {
        var prefixs = ['webkit','moz','mos','o'];
        if ( "hidden" in document ) return document.hidden;
        for (var i = 0; i < prefixs.length; i++) {
            if ( prefixs[i]+"Hidden" in document ){
                return document[ prefixs[i]+"Hidden" ];
            }
        }
        // not support
        return null;
    };

    PlatformUC.prototype.visibilitychange = function(callback){
        var _this = this;
        document && document.addEventListener("visibilitychange", function(){
            var isHidden = _this.getHidden();
            // if( isHidden ){
            //     console.log(  "[pageHiddenHandler] 藏起来了" );
            //     // MediaControl.stopBGM();
            // } else {
            //     console.log(  "[pageHiddenHandler] 闪现" );
            //     // MediaControl.playBGM( MediaControl.bgmTypeId );
            // }
            callback && callback.call(this, !!isHidden);
        }, false);
    };

    PlatformUC.prototype.gameWindowActive = function(){
        console.log( "[platform] gameNativeActive" );
    };

    PlatformUC.prototype.gameWindowHide = function(){
        console.log( "[platform] gameWindowHide" );
        window.gameBgMusicOff();
    };

    PlatformUC.prototype.showBannerAd = function(){

    };

    PlatformUC.prototype.hideBannerAd = function(){

    };

    PlatformUC.prototype.showRewardedVideo = function(adPosNum){
        console.log( "[showRewardedVideo] start...." );

        var _this = this;

        return new Promise(function(resolve, reject) {
            var rewardedVideoAd;
            if( window.uc && window.uc.createRewardVideoAd ){
                rewardedVideoAd = window.uc.createRewardVideoAd();
            } else {
                console.log( "[showRewardedVideo] uc undefined" );
                return resolve( false );
            }

            if( rewardedVideoAd ){
                rewardedVideoAd.show()
                .catch(function(err){
                    console.log( "[showRewardedVideo] err=", err );
                    resolve( false );
                });

                rewardedVideoAd.onLoad(function(){
                    console.log('激励视频 广告加载成功');
                });

                rewardedVideoAd.onClose(function(res){
                    // 用户点击了【关闭广告】按钮
                    if (res && res.isEnded) {
                        // 正常播放结束，可以下发游戏奖励
                        resolve( true );
                    } else {
                        // 播放中途退出，不下发游戏奖励
                        resolve( false );
                    }
                    console.log( "[showRewardedVideo] isEnded=", res && res.isEnded );
                });
            } else {
                resolve( false );
            }
        });
    };

    PlatformUC.prototype.showInterstitial = function(){
        
    };

    PlatformUC.prototype.showFullVideo = function(){
        
    };

    PlatformUC.prototype.showSplash = function(){

    };

    return PlatformUC;
}();

var PlatformAndroidWeb = function(){
    function PlatformAndroidWeb() {
        this.platformType = "androidWeb";
        this.__rewardAdIsPlaying = false;
        return this;
    }

    PlatformAndroidWeb.prototype.sendEvent = function(){

    },

    /**
     * 震动
     */
    PlatformAndroidWeb.prototype.vibrateShort = function() {
        window.vibrator && window.vibrator.show(50);
    };

    /**
     * 获取网络状态
     * @param {*} callback 
     */
    PlatformAndroidWeb.prototype.getNetworkType = function(callback) {
        return callback.call(this, "unknown");
    };

    PlatformAndroidWeb.prototype.getSystemInfo = function(callback){
        window.devInfo && window.devInfo.getImei(function(data){
            console.log("[getSystemInfo] devInfo=", data);

            // if( data && typeof data == "string" ){
            //     data = JSON.parse( data );
            // }

            callback && callback.call(this, data || null);
        });
    };

    /**
     * 获取imei码
     */
    PlatformAndroidWeb.prototype.getImeiCode = function() {
        var _imei,
            imeiName = storeName.imeiCode;

        _imei = window.localStorage.getItem(imeiName);

        if (!_imei) {
            var rand = Math.floor(10000000 * Math.random()) + "" + new Date().getTime();
            _imei = MD5(rand).slice(0, 15);
            window.localStorage.setItem(imeiName, _imei);
        }

        return _imei;
    };

    /**
     * 获取设备码
     */
    PlatformAndroidWeb.prototype.getDevCode = function() {
        var _imei, _dev, _salt = "salt_sx1kedsl",
        devName = storeName.devCode;

        _dev = window.localStorage.getItem(devName);

        if (!_dev) {
            _imei = this.getImeiCode();
            _dev = MD5(_imei + _salt);
            window.localStorage.setItem(devName, _dev);
        }

        return _dev;
    };

    PlatformAndroidWeb.prototype.devActive = function(){
        console.log("[devActive] 设备登录开始");
        var _this = this;

        this.getSystemInfo(function(devInfo){
            console.log("[devActive] getSystemInfo=", devInfo);

            if( devInfo && typeof devInfo == "string" ){
                devInfo = JSON.parse( devInfo );
                console.log( "[devActive] data parse=", devInfo );
            }

            if( !devInfo || !devInfo.imei ) {
                return console.log( "[devActive] data error" );
            }

            var url = interface.devActive;
            var _imei = devInfo.imei;
            var _dev = devInfo.dev;
            var sysType = 2;    //android=2，iOS=1
            var OSversion = devInfo.osv;
            var networkType = "unkown";
            var pixelRatio = window.devicePixelRatio;
            var width = window.screen.width;
            var height = window.screen.height;
            if ( pixelRatio > 1 ){
                width = width * pixelRatio;
                height = height * pixelRatio;
            }

            window.localStorage.setItem(storeName.imeiCode, _imei);
            window.localStorage.setItem(storeName.devCode, _dev);


            console.log("[devActive] 网络状态正常，网络类型=", networkType);

            var arr = [
                "refer=" + config.refer,
                "dev=" + _dev,
                "imei=" + _imei,
                "os=" + sysType,
                "gname=" + encodeURIComponent(config.gname),
                "dpgn=" + config.pkgName,
                "brand=" + encodeURIComponent(devInfo.brand),
                "mode=" + encodeURIComponent(devInfo.model),
                "sver=" + config.sdkVersion,
                "wpi=" + width,
                "hpi=" + height,
                "osver=" + encodeURIComponent(OSversion),
                "pver=" + config.reviewVersion,
                "nwk=" + networkType,
                "token=" + MD5(Math.random()*1000000)
            ];

            url = url + "?" + arr.join("&");
            console.log("[devActive] url=", arr.join("&"));

            var img = new Image();
            img.src = url;
            img.onload = function(){
                console.log( "[devActive] 设备登录成功" );
            }
        });
    };
    PlatformAndroidWeb.prototype.serverLogin = function(){};

    /**
    * 等级通关上报
    */
    PlatformAndroidWeb.prototype.reportNewLevel = function(level, type) {
        type = type || 1;
        var data2 = [
            "refer=" + config.refer,
            "uid=",
            "dev=" + this.getDevCode(),
            "eid=" + (type == 2 ? 38 : 35),
            "drlevel=" + (level || 0)
        ],

        _url = interface.reportNewLevel + "?" + data2.join("&") + "&r=" + Math.random();

        console.log( "[reportNewLevel] url=", _url );

        var img = new Image();
        img.src = _url;
        img.onload = function(){
            console.log( "[reportNewLevel] 上报成功！上报等级=", level );
        }
    };

    PlatformAndroidWeb.prototype.reportEventsClick = function(){};

    PlatformAndroidWeb.prototype.getGameConfig = function(callback) {
        var _this = this;
        var url = interface.gameConfig + "?v=" + Math.random();
        url = url.replace( "{$sdkver}", config.sdkVersion )
        .replace( "{$media}", config.media );

        var xhr = new XMLHttpRequest();
        xhr.open("GET", url, true);
        xhr.addEventListener("load", function () {
            if( xhr.response ){
                var res = JSON.parse(xhr.response);
                window.adConfigData = res.adConfigData;
                _this.adConfigData = res.adConfigData;
                window.popAd = res.popAd;
                _this.popAd = res.popAd;
                window.adConfigData && window.toutiao && window.toutiao.adInit(window.adConfigData.toutiao.adInit);

                callback && callback.call( this, res );
            }
        });
        xhr.send(null);
    };

    PlatformAndroidWeb.prototype.gameNativeActive = function(){
        console.log( "[gameNativeActive]" );
        // this.showFullVideo();
        if( this.popAd && this.adConfigData && this.adConfigData.backAd && this.adConfigData.backAd == true && this.adConfigData.backAdPercent > 0 ) {
            var rand = Math.floor( Math.random() * 10 );
            if( rand < this.adConfigData.backAdPercent ){
                this.showFullVideo();
            } else {
                console.log( "[gameNativeActive] 没中" );
            }
        } else {
            console.log( "[gameNativeActive] 广告关闭" );
        }
    };

    PlatformAndroidWeb.prototype.getAdBrand = function( adtype ){
        return "toutiao";
        // if( !adtype ) return console.log( "[this] getAdBrand adtype error." );
        // var cfg = this.adcfg;
        // var chance = cfg[ adtype ];
        // if( !chance ) return console.log( "[this] getAdBrand adtype not found." );
        // var chance_gdt = cfg[adtype].gdt || 0,
        //     chance_toutiao = cfg[adtype].toutiao || 0,
        //     brand = "",
        //     rand = Math.floor( Math.random()*10 ) +1;

        // if( chance_gdt > 0 && rand <= chance_gdt ) {
        //     brand = "gdt";
        // } else {
        //     brand = "toutiao";
        // }
        // console.log( "[this] getAdBrand=", brand, rand );
        // return brand;
    };

    PlatformAndroidWeb.prototype.showBannerAd = function(){
        console.log( "[PlatformAndroidWeb] showBannerAd" );
        if( this.bannerCloseTimer ){
            window.clearTimeout(this.bannerCloseTimer);
        }
        var adBrand = this.bannerAdBrand = this.getAdBrand("showBanner");
        if ( window.adConfigData && window[adBrand] ) {
            window[adBrand].showBanner();
        }
    };

    PlatformAndroidWeb.prototype.hideBannerAd = function(){
        console.log( "[PlatformWeb] hideBannerAd" );
        //取打开的banner
        var _this = this,
            adBrand = this.bannerAdBrand;
        if ( adBrand && window.adConfigData && window[adBrand] ) {
            window[adBrand].closeBanner();
            this.bannerAdBrand = null;
            //防止未关闭
            this.bannerCloseTimer = window.setTimeout(function(){
                window[adBrand].closeBanner();
            }, this, 2000);
        }
    };

    PlatformAndroidWeb.prototype.showRewardedVideo = function(adPosNum){
        if ( !window.adConfigData ) {
            return console.log( "[showRewardedVideo] get video config error!" );
        } else {
            console.log( "[showRewardedVideo] start...." );
        }

        var _this = this;

        return new Promise(function(resolve, reject) {
            if ( _this.__rewardAdIsPlaying === true ) {
                console.log("[showRewardedVideo] video is playing");
                return resolve(false);
            } else {
                _this.__rewardAdIsPlaying = true;
                window.setTimeout(function() {
                    _this.__rewardAdIsPlaying = false;
                }, _this, 5000);
            }

            try {
                var adBrand = _this.getAdBrand("rewardVideo");
                console.log( "[showRewardedVideo] adBrand=", adBrand );

                if( !window[adBrand] || !window[adBrand].showRewardVideo ){
                    console.log( "[showRewardedVideo] no showRewardVideo" );
                    return resolve(false);
                }

                window[adBrand].showRewardVideo(function(){
                    console.log( "[showRewardedVideo] success" );
                    _this.__rewardAdIsPlaying = false;
                    _this.reportEventsClick(adPosNum, adBrand, true);
                    resolve( true );
                }, function(){
                    console.log( "[showRewardedVideo] fail" );
                    _this.__rewardAdIsPlaying = false;
                    _this.reportEventsClick(adPosNum, adBrand, false);
                    resolve(false);
                });
            } catch( err ){
                err && console.log( err );
            }
        });
    };

    PlatformAndroidWeb.prototype.showInterstitial = function(){
        console.log( "[showInterstitial]"  );
        var adBrand = this.getAdBrand("showInterstitial");
        if ( window[adBrand] ) {
            window[adBrand].showInterstitial();
        }
    };

    PlatformAndroidWeb.prototype.showFullVideo = function(){
        console.log( "[showFullVideo]" );
        var adBrand = this.getAdBrand("showFullVideo");
        window[adBrand].showFullVideo && window[adBrand].showFullVideo();
    };

    PlatformAndroidWeb.prototype.showSplash = function(){
        var adBrand = this.getAdBrand("showSplashScreen");
        console.log( "[showSplash]", adBrand );
        if ( window[adBrand] ) {
            window[adBrand].showSplashScreen();
        }
    };

    return PlatformAndroidWeb;
}();

var PlatformWechat = function(){
    function platformWechat() {
        this.platformType = "wechat";
        this.__rewardAdIsPlaying = false;
        this.isLogin = false;
        this.interface = interface;

        return this;
    }

    /**
     * 获取网络状态
     * @param {*} callback 
     */
    platformWechat.prototype.getNetworkType = function(callback) {
        wx.getNetworkType({
            success: function(res) {
                var networkType = res.networkType;
                callback.call(this, networkType || "unknown");
            }
        });
    },

    /**
     * 获取imei码
     */
    platformWechat.prototype.getImeiCode = function() {
        var _imei,
            imeiName = "imeiCode";

        _imei = wx.getStorageSync(imeiName);

        if (!_imei) {
            var rand = Math.floor(10000000 * Math.random()) + "" + new Date().getTime();
            _imei = MD5(rand).slice(0, 15);
            wx.setStorageSync(imeiName, _imei);
        }

        return _imei;
    },

    /**
     * 获取设备码
     */
    platformWechat.prototype.getDevCode = function() {
        var _imei, _dev, _salt = "salt_sx1kedsl",
        devName = "devCode";

        _dev = wx.getStorageSync(devName);

        if (!_dev) {
            _imei = this.getImeiCode();
            _dev = MD5(_imei + _salt);
            wx.setStorageSync(devName, _dev);
        }

        return _dev;
    },

    /**
     * 设备登录
     */
    platformWechat.prototype.devActive = function() {
        var _this = this;
        var devInfo = wx.getSystemInfoSync();
        var _imei = this.getImeiCode();
        var _dev = this.getDevCode();
        var url = interface.devActive;
        var sysType = 1;
        var system = devInfo.system;
        var OSversion;

        this.getNetworkType(function(networkType) {
            if (/^iOS\s{1}/.test(system)) {
                sysType = 1;
                OSversion = system.slice(4);
            } else if (/^Android\s{1}/.test(system)) {
                sysType = 2;
                OSversion = system.slice(8);
            } else {
                sysType = 3;
                OSversion = "unknow";
            }

            var arr = [
                "refer=" + config.refer,
                "dev=" + _dev, "imei=" + _imei,
                "os=" + sysType,
                "gname=" + encodeURIComponent(config.gname),
                "dpgn=" + config.appid,
                "brand=" + encodeURIComponent(devInfo.brand),
                "mode=" + encodeURIComponent(devInfo.model),
                "sver=" + config.sdkVersion,
                "wpi=" + devInfo.screenWidth,
                "hpi=" + devInfo.screenHeight,
                "osver=" + encodeURIComponent(OSversion),
                "pver=" + config.reviewVersion,
                "nwk=" + networkType
            ];

            url = url + "?" + arr.join("&");

            wx.request({
                url: url,
                header: {
                    "content-type": "application/x-www-form-urlencoded"
                },
                data: {},
                method: "GET"
            });

            console.log( "[devActive] url=", url );
        });
    },

    platformWechat.prototype.wxLogin = function(callback, fail){
        wx.login({
            success: function(res) {
                callback && res && callback.call(this, res.code);
            },
            fail: function(err) {
                fail && fail.call(this, err);
            },
            complete: function(e) {}
        });
    },

    /**
     * 服务端登录
     * @param {*} successHandler 成功回调 [可选]
     * @param {*} failHanlder 失败回调 [可选]
     */
    platformWechat.prototype.serverLogin = function( successHandler, failHanlder ){
        var _this = this;

        if( this.isLogin === true && this.userid ){
            return console.log( "[serverLogin] 已经登录" );
        }

        this.wxLogin(function(code){
            if( !code ){
                return console.log( "[serverLogin] wxcode error" );
            }

            var token = wx.getStorageSync("user_token") || "";
            var ext = {
                uuid: _this.getDevCode()
            };

            var userData = {
                refer: config.refer,
                wxappid: config.wxappid,
                wxsnsid: code,
                token: token,
                ext: JSON.stringify(ext)
            };

            wx.request({
                url: interface.login,
                method: "POST",
                data: userData,
                header: {
                    "content-type": "application/x-www-form-urlencoded"
                },
                success: function(res) {
                    console.log( "[serverLogin] 登录成功=", res && JSON.stringify(res) );
                    var data = res.data;
                    if( data && data.code == 1 && data.data ) {
                        try {
                            data = JSON.parse( data.data );
                            wx.aldSendOpenid(data.openid);
                            if( data && data.token && data.uid  ) {
                                wx.setStorageSync( "user_token", data.token );
                                wx.setStorageSync( "user_openid", data.openid );
                                wx.setStorageSync( "user_uid", data.uid );
                                _this.userid = data.uid;
                                _this.isLogin = true;
                                successHandler && successHandler.call( this, res );
                            } else {
                                failHanlder && failHanlder(1, data);
                                _this.isLogin = false;
                            }
                        } catch(err) {
                            failHanlder && failHanlder(2, err);
                            _this.isLogin = false;
                        }
                    } else {
                        failHanlder && failHanlder(3);
                        _this.isLogin = false;
                    }
                },
                fail: function(msg) {
                    failHanlder && failHanlder.call( this, 4, msg );
                    _this.isLogin = false;
                }
            });



        }, function(err){
            console.log( "[serverLogin] wx登录失败=", err );
        });
    },

    /**
     * 等级上报
     */
    platformWechat.prototype.reportNewLevel = function( maxLevel ) {
        if( !CC_WECHATGAME )return;
        if( maxLevel === "undefined" || +maxLevel < 0 ){
            return console.log( "[reportNewLevel] 参数错误=", maxLevel );
        }

        var data = [
            "refer=" + config.refer,
            "uid=" + this.userid,
            "dev=" + this.getDevCode(),
            "eid=" + (maxLevel > 0 ? 35 : 31),
            "drlevel=" + (maxLevel || 0)
        ],

        url = interface.reportNewLevel + "?" + data.join("&") + "&r=" + Math.random();

        wx.request({
            url: url,
            header: { "content-type": "application/x-www-form-urlencoded" },
            data: {},
            method: "GET"
        });

        console.log( "[reportNewLevel] url=", url );
    }
}


var PlatformCreate = function(type) {
    switch (type) {
        case "web":
            return new PlatformWeb();

        case "uc":
            return new PlatformUC();

        case "wechat":
            return new PlatformWechat();

        case "ios":
            return new PlatformiOS();

        case "oppo":
            return new PlatformOppo();

        case "vivo":
            return new PlatformVivo();
    
        case "androidWeb":
            return new PlatformAndroidWeb();

        default:
            return null;
    }
};